<?php

namespace Litecms\MatchingCommission;

use User;

class MatchingCommission
{
    /**
     * $matching_commission object.
     */
    protected $matching_commission;

    /**
     * Constructor.
     */
    public function __construct(\Litecms\MatchingCommission\Interfaces\MatchingCommissionRepositoryInterface $matching_commission)
    {
        $this->matching_commission = $matching_commission;
    }

    /**
     * Returns count of matching_commission.
     *
     * @param array $filter
     *
     * @return int
     */
    public function count()
    {
        return  0;
    }

    /**
     * Make gadget View
     *
     * @param string $view
     *
     * @param int $count
     *
     * @return View
     */
    public function gadget($view = 'admin.matching_commission.gadget', $count = 10)
    {

        if (User::hasRole('user')) {
            $this->matching_commission->pushCriteria(new \Litepie\Litecms\Repositories\Criteria\MatchingCommissionUserCriteria());
        }

        $matching_commission = $this->matching_commission->scopeQuery(function ($query) use ($count) {
            return $query->orderBy('id', 'DESC')->take($count);
        })->all();

        return view('matching_commission::' . $view, compact('matching_commission'))->render();
    }
}
